//extension of JS array object with in_array function
Array.prototype.in_array = function (obj)
{
	var len = this.length;
	for ( var x = 0 ; x <= len ; x++ )
	{
		if ( this[x] == obj ) return true;
	}
	return false;
}

//returns XMLHTTP object
function createXMLHttp()
{
    var ret = null;
    try {
        ret = new ActiveXObject('Msxml2.XMLHTTP');
    }
    catch (e) {
        try {
            ret = new ActiveXObject('Microsoft.XMLHTTP');
        }
        catch (ee) {
            ret = null;
        }
    }
    if (!ret && typeof XMLHttpRequest != 'undefined')
        ret = new XMLHttpRequest();

    return ret;
}

//conferts string with js array to js array
function receivejsarray(code)
{
    eval('var ret = ' + code);
    return ret;
}

//page initialization. Should be called right after the complete page load.
function init()
{
	refresh_pub_type();
	init_ajax();
}

//init ajax enabled forms
function init_ajax()
{
	var publisher = document.getElementById('publisher_sel');
	var conference = document.getElementById('conference_sel');
	var journal = document.getElementById('journal_sel');

	if (publisher != null)
	publisher.onchange = function()
	{
		try
		{
			xhr = createXMLHttp();
			xhr.open('get', 'detail_provider.php?' + 'publisher=' + publisher.value);
			xhr_xmlhttpsuccess = function()
			{
				arr = receivejsarray(xhr.responseText);
				enable_publisher_edit(arr[0], arr[1], arr[2]);
			}
			xhr_onreadystatechange = function()
			{
				if (xhr.readyState == 4 && xhr.status == 200 && xhr_xmlhttpsuccess)
				{
					xhr_xmlhttpsuccess();
				}
			}
			xhr.onreadystatechange = xhr_onreadystatechange;
			xhr.send(null);
		}
		catch (e)
		{
			alert(e.message);
		}
		return false;
	}

	if (conference != null)
	conference.onchange = function()
	{
		if (window.forbidden_conferences !== undefined)
			validate_conference_selection(forbidden_conferences); //forbidden_conferences is a variable defined outside this function
		try
		{
			xhr = createXMLHttp();
			xhr.open('get', 'detail_provider.php?' + 'conference=' + conference.value);
			xhr_xmlhttpsuccess = function()
			{
				arr = receivejsarray(xhr.responseText);
				enable_conference_edit(arr[0], arr[1], arr[2], arr[3], arr[4], arr[5], arr[6], arr[7]);
			}
			xhr_onreadystatechange = function()
			{
				if (xhr.readyState == 4 && xhr.status == 200 && xhr_xmlhttpsuccess)
				{
					xhr_xmlhttpsuccess();
				}
			}
			xhr.onreadystatechange = xhr_onreadystatechange;
			xhr.send(null);
		}
		catch (e)
		{
			alert(e.message);
		}
		return false;
	}

	if (journal != null)
	journal.onchange = function()
	{
		try
		{
			xhr = createXMLHttp();
			xhr.open('get', 'detail_provider.php?' + 'journal=' + journal.value);
			xhr_xmlhttpsuccess = function()
			{
				arr = receivejsarray(xhr.responseText);
				enable_journal_edit(arr[0], arr[1], arr[2]);
			}
			xhr_onreadystatechange = function()
			{
				if (xhr.readyState == 4 && xhr.status == 200 && xhr_xmlhttpsuccess)
				{
					xhr_xmlhttpsuccess();
				}
			}
			xhr.onreadystatechange = xhr_onreadystatechange;
			xhr.send(null);
		}
		catch (e)
		{
			alert(e.message);
		}
		return false;
	}
}

/* Enable editing of publisher. parameter forbidden indicates whether to forbid
   editing of name or not */
function enable_publisher_edit(forbidden, name, address)
{
	elem = document.getElementById('publisher_label');
	elem.style.display = 'block';
	p_name = document.getElementById('publisher_name');
	p_name.disabled = '';
	if (forbidden != 0)
		p_name.disabled = 'disabled';
	p_name.value = name;
	document.getElementById('publisher_address').value = address;
	document.getElementById('update_publisher').style.display = 'inline';
	document.getElementById('add_publisher').style.display = 'none';
}


function disable_publisher_edit()
{
	elem = document.getElementById('publisher_label');
	elem.style.display = 'none';
	p_name = document.getElementById('publisher_name');
	p_name.value = '';
	p_name.disabled = '';
	document.getElementById('publisher_address').value = '';
	document.getElementById('update_publisher').style.display = 'none';
	document.getElementById('add_publisher').style.display = 'inline';
}

/* Enable editing of conference. parameter allow_edit indicates what
   level of editability is permitted for the current conference */
function enable_conference_edit(allow_edit, name, abbreviation, w_year, w_from, w_to, location, isbn)
{
	elem = document.getElementById('conference_label');
	elem.style.display = 'block';
	c_name = document.getElementById('conference_name');
	c_year = document.getElementById('w_year');
	c_name.disabled = '';
	c_year.disabled = '';
	if (allow_edit == 0) //name and year should be disabled
	{
		c_name.disabled = 'disabled';
		c_year.disabled = 'disabled';
	}
	else if (allow_edit == 1) //allow editing year, but without name
	{
		c_name.disabled = 'disabled';
		c_year.disabled = '';
	}
	else if (allow_edit == 2) //allow editiong all including name and year
	{
		c_name.disabled = '';
		c_year.disabled = '';
	}
	c_name.value = name;
	document.getElementById('conference_abbreviation').value = abbreviation;
	c_year.value = w_year;
	document.getElementById('w_from').value = w_from;
	document.getElementById('w_to').value = w_to;
	document.getElementById('location').value = location;
	document.getElementById('conference_isbn').value = isbn;
	document.getElementById('update_conference').style.display = 'inline';
	document.getElementById('add_conference').style.display = 'none';
}

function disable_conference_edit()
{
	elem = document.getElementById('conference_label');
	elem.style.display = 'none';
	c_name = document.getElementById('conference_name');
	c_year = document.getElementById('w_year');
	c_name.value = '';
	c_name.disabled = '';
	document.getElementById('conference_abbreviation').value = '';
	c_year.value = '';
	c_year.disabled = '';
	document.getElementById('w_from').value = '';
	document.getElementById('w_to').value = '';
	document.getElementById('location').value = '';
	document.getElementById('conference_isbn').value = '';
	document.getElementById('update_conference').style.display = 'none';
	document.getElementById('add_conference').style.display = 'inline';
}

/* Enable editing of journal. parameter forbidden indicates whether to forbid name
   editing or not */
function enable_journal_edit(forbidden, name, issn)
{
	elem = document.getElementById('journal_label');
	elem.style.display = 'block';
	j_name = document.getElementById('journal_name');
	j_name.disabled = '';
	if (forbidden != 0)
		j_name.disabled = 'disabled';
	j_name.value = name;
	document.getElementById('journal_issn').value = issn;
	document.getElementById('update_journal').style.display = 'inline';
	document.getElementById('add_journal').style.display = 'none';
}


function disable_journal_edit()
{
	elem = document.getElementById('journal_label');
	elem.style.display = 'none';
	j_name = document.getElementById('journal_name');
	j_name.value = '';
	j_name.disabled = '';
	document.getElementById('journal_issn').value = '';
	document.getElementById('update_journal').style.display = 'none';
	document.getElementById('add_journal').style.display = 'inline';
}

/* unselect all options in html select box.
   parameter id is id of html element in the document */
function unset_memo(id)
{
	sel = document.getElementById(id);
	for (i = 0; i < sel.options.length; i++)
	{
		sel.options[i].selected = false;
	}
	disable_publisher_edit();
}

/* if chosen conference is forbidden, don't allow the user to select it
   paremeter forbidden should be a JS array of conference ids */
function validate_conference_selection(forbidden)
{
	conference = document.getElementById('conference_sel');
	conference_id = conference.value;
	if (forbidden != null && forbidden.in_array(conference_id))
	{
		alert("You can't choose this conference, because is non-complete and you are not it's owner.");
		unset_memo('conference_sel');
		disable_conference_edit();
		return false;
	}
}

//enables or disables data field in modify publication form
function set(element, state)
{
	element.style.display = state?'':'none';
	e_input = element.getElementsByTagName('input');
	if (e_input.length == 1 && state == 0)
	e_input[0].value = ''; //clear the input
	e_select = element.getElementsByTagName('option');
	if (e_select.length > 0 && state == 0)
	{
		for (i = 0; i < e_select.length; i++)
		{
			e_select[i].selected = null;
		}

	}
}

/* regenerates modify publication form to display only tohose data fields which
   are useful for current publication type */
function refresh_pub_type()
{
	var pub_type = document.getElementById("pub_type");
	var address = document.getElementById("address");
	var author = document.getElementById('author');
	var booktitle = document.getElementById('booktitle');
	var chapter = document.getElementById('chapter');
	var edition = document.getElementById('edition');
	var editor = document.getElementById('editor');
	var howpublished = document.getElementById('howpublished');
	var institution = document.getElementById('institution');
	var number = document.getElementById("number");
	var organization = document.getElementById('organization');
	var pages = document.getElementById('pages');
	var school = document.getElementById('school');
	var series = document.getElementById('series');
	var type = document.getElementById('type');
	var volume = document.getElementById("volume");
	var isbn = document.getElementById("isbn");
	var publisher = document.getElementById('publisher');
	var conference = document.getElementById('conference');
	var journal = document.getElementById('journal');
	var issue_date = document.getElementById('issue_date');

	var type_value = pub_type.options[pub_type.selectedIndex].value;
	switch(type_value)
	{
		case("article"):
		set(address, 0);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 0);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 1);
		set(number, 1);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 0);
		set(volume, 1);
		set(isbn, 0);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("book"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 1);
		set(editor, 1);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 1);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 1);
		set(school, 0);
		set(series, 1);
		set(type, 0);
		set(volume, 1);
		set(isbn, 1);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("booklet"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 0);
		set(howpublished, 1);
		set(institution, 0);
		set(journal, 0);
		set(number, 0);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 0);
		set(volume, 0);
		set(isbn, 0);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("inbook"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 1);
		set(edition, 1);
		set(editor, 1);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 1);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 1);
		set(school, 0);
		set(series, 1);
		set(type, 0);
		set(volume, 1);
		set(isbn, 1);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("incollection"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 1);
		set(chapter, 1);
		set(edition, 1);
		set(editor, 1);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 1);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 1);
		set(school, 0);
		set(series, 1);
		set(type, 0);
		set(volume, 1);
		set(isbn, 1);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("inproceedings"):
		set(address, 0); //HIDDEN IN CONFERENCE
		set(author, 1);
		set(booktitle, 0); //HIDDEN IN CONFERENCE
		set(chapter, 1);
		set(edition, 0);
		set(editor, 1);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 1);
		set(organization, 1);
		set(pages, 1);
		set(publisher, 1);
		set(school, 0);
		set(series, 1);
		set(type, 0);
		set(volume, 1);
		set(isbn, 0);  //HIDDEN IN CONFERENCE
		set(conference, 1);
		set(issue_date, 0); //HIDDEN IN CONFERENCE
		break;
		case("manual"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 1);
		set(editor, 0);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 0);
		set(organization, 1);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 0);
		set(volume, 0);
		set(isbn, 0);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("mastersthesis"):
		case("phdthesis"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 0);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 0);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 1);
		set(series, 0);
		set(type, 0);
		set(volume, 0);
		set(isbn, 0);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("misc"):
		set(address, 0);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 1);
		set(howpublished, 1);
		set(institution, 0);
		set(journal, 0);
		set(number, 0);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 0);
		set(volume, 0);
		set(isbn, 0);

		set(conference, 0);
		set(issue_date, 1);
		break;
		case("proceedings"):
		set(address, 0); //HIDDEN IN CONFERENCE'S `location`
		set(author, 0);
		set(booktitle, 0); //HIDDEN IN CONFERENCE
		set(chapter, 0);
		set(edition, 0);
		set(editor, 1);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 1);
		set(organization, 1);
		set(pages, 1);
		set(publisher, 1);
		set(school, 0);
		set(series, 1);
		set(type, 0);
		set(volume, 1);
		set(isbn, 1);
		set(conference, 1);
		set(issue_date, 0); //HIDDEN IN CONFERENCE
		break;
		case("techreport"):
		set(address, 1);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 0);
		set(howpublished, 0);
		set(institution, 1);
		set(journal, 0);
		set(number, 1);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 1);
		set(volume, 0);
		set(isbn, 0);
		set(conference, 0);
		set(issue_date, 1);
		break;
		case("unpublished"):
		set(address, 0);
		set(author, 1);
		set(booktitle, 0);
		set(chapter, 0);
		set(edition, 0);
		set(editor, 0);
		set(howpublished, 0);
		set(institution, 0);
		set(journal, 0);
		set(number, 0);
		set(organization, 0);
		set(pages, 1);
		set(publisher, 0);
		set(school, 0);
		set(series, 0);
		set(type, 0);
		set(volume, 0);
		set(isbn, 0);
		set(conference, 0);
		break;
	}

}