<?php

require_once('../common/Convertor.inc.php');
require_once('../common/misc_fns.inc.php');
require_once('../common/db_fns.inc.php');

$db = db_connect();
$db->query("DELETE FROM `documents`");
echo ("Clearing table `documents` <br />");
$res = $db->query("select id, title from publication");
while ($row =& $res->fetchRow())
{
	add_document($row[0], $row[1]);
}

function add_document($publication_id, $title)
{
	$path="../storage/$publication_id";
	if (file_exists($path))
	{
		$handle=opendir($path);
		global $db;
		$convertor = new Convertor($db, $publication_id, $title);
		while ($file = readdir($handle))
		{
			$dst_filename = $path.'/'.$file;
			if (is_file($dst_filename))
			{
				echo ("Adding file $dst_filename <br />");
				$convertor->add_file($file);
			}
		}
		print $convertor->finish();
	}
}
?>