<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	{if $refresh}<meta http-equiv="refresh" content="{$refresh}" />{/if}
	<title>Database of publications - administration</title>
		<link rel="stylesheet" type="text/css" href="admin.css" />
	<link rel="stylesheet" type="text/css" href="../common/header.css" />
</head>
<body>

	{include file="header.tpl"}

	<div id="mainpanel">
	<div id="mainpanel-inside">
		<ul id="tabmenu">
			<li><a href="index.php">Waiting for check</a></li>
			<li><a href="index.php?tab=2">Checked</a></li>
			<li><a href="index.php?tab=3">Attributes</a></li>
			<li><a class="active" href="index.php?tab=4">Categories</a></li>
			<li><a href="index.php?tab=5">Authors</a></li>
			<li><a href="index.php?tab=6">Publishers</a></li>
			<li><a href="index.php?tab=7">Journals</a></li>
			<li><a href="index.php?tab=8">Conferences</a></li>
			<li><a href="index.php?tab=9">Templates</a></li>
			<li><a href="index.php?tab=10">Users</a></li>
		</ul>

		<div id="content">
		{if $operation_error}
			<span class="error">{$operation_error}</span><br/><br/>
		{elseif $operation_success}
			<span class="success">{$operation_success}</span><br/><br/>
		{/if}

		{if $show_categories}
			<form method="post" action="index.php?tab=4" enctype="multipart/form-data">
			<table id="list" border="0" cellspacing="0" cellpadding="8" summary="List of all categories">
			<thead>
			<tr class="heading">
				<th scope="col"><a href="index.php?tab=4&amp;order=1">name</a></th>
				<th scope="col" colspan="2">&nbsp;</th>
			</tr>
			</thead>
			{foreach from=$categories item=arr}
			<tr class="{cycle values="odd,even"}">
				<td>{$arr.name|escape:"html"}</td>
				<td><input type="submit" name="edit_category[{$arr.id}]" value="change" /> </td>
				<td>
					<input type="submit" name="delete_category[{$arr.id}]" value="delete" />
					{if $arr.warning}<img src="../graphics/warn.png" alt="varování" title="This category is associated with some publications, don´t delete."/>{/if}
				</td>
			</tr>
			{/foreach}
			<tr>
				<td>&nbsp;</td>
				<td><input type="text" id="new_category_name" name="new_category_name" maxlength="40" value="{$new_category_name}" title="attribute name: max. 40 characters, first character underline, other characters letters and numerals." /></td>
				<td colspan="2" class="right"><input type="submit" name="add_category" value="add category" /></td>
			</tr>
			</table>
			<br />
			<br />
			</form>
		{elseif $edit_category}
			<a href="index.php?tab=4">&lt;&lt;</a>
			<br />
			<br />
			<form method="post" action="index.php?tab=4" enctype="multipart/form-data">
			<label>name of category: <input type="text" size="20" maxlength="40" name="name" value="{$name|escape:"html"}" /></label><br />
			<br />
			<br />
			<hr />
			<br />
			<input type="hidden" name="categories_id" value="{$categories_id}" />
			<div class="right"><input type="submit" name="save_edited_category" value="save" /></div>
			</form>
		{/if}
		</div>
	</div>
	</div>
</body>
</html>
