-- phpMyAdmin SQL Dump
-- version 2.6.4-pl4-Debian-2
-- http://www.phpmyadmin.net
--
-- Počítač: localhost
-- Vygenerováno: Čtvrtek 29. června 2006, 21:13
-- Verze MySQL: 5.0.16
-- Verze PHP: 5.0.5-3

SET FOREIGN_KEY_CHECKS=0;

SET AUTOCOMMIT=0;
START TRANSACTION;

--
-- Databáze: `vodicm1`
--

-- --------------------------------------------------------

--
-- Struktura tabulky `attrib_storage`
--

CREATE TABLE `attrib_storage` (
  `publication_id` int(10) unsigned NOT NULL,
  `attributes_id` int(10) unsigned NOT NULL,
  `submitter_id` int(10) unsigned default NULL,
  `value` text,
  PRIMARY KEY  (`publication_id`,`attributes_id`),
  KEY `attrib_storage_FKIndex1` (`publication_id`),
  KEY `attrib_storage_FKIndex2` (`submitter_id`),
  KEY `attrib_storage_FKIndex3` (`attributes_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Vypisuji data pro tabulku `attrib_storage`
--

INSERT INTO `attrib_storage` (`publication_id`, `attributes_id`, `submitter_id`, `value`) VALUES (34, 5, 2, '1. vydání');
INSERT INTO `attrib_storage` (`publication_id`, `attributes_id`, `submitter_id`, `value`) VALUES (36, 5, 2, '1.');
INSERT INTO `attrib_storage` (`publication_id`, `attributes_id`, `submitter_id`, `value`) VALUES (37, 5, 2, 'vol I.');
INSERT INTO `attrib_storage` (`publication_id`, `attributes_id`, `submitter_id`, `value`) VALUES (40, 5, 2, '1. vydání');
INSERT INTO `attrib_storage` (`publication_id`, `attributes_id`, `submitter_id`, `value`) VALUES (50, 5, 2, '1. vydání');

-- --------------------------------------------------------

--
-- Struktura tabulky `attributes`
--

CREATE TABLE `attributes` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `submitter_id` int(10) unsigned default NULL,
  `name` varchar(32) default NULL,
  `description` varchar(255) default NULL,
  `confirmed` tinyint(1) default '0',
  PRIMARY KEY  (`id`),
  KEY `attributes_FKIndex1` (`submitter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

--
-- Vypisuji data pro tabulku `attributes`
--

INSERT INTO `attributes` (`id`, `submitter_id`, `name`, `description`, `confirmed`) VALUES (5, 2, '_vydani', 'poznámky k vydání', 1);

-- --------------------------------------------------------

--
-- Struktura tabulky `author`
--

CREATE TABLE `author` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `submitter_id` int(10) unsigned default NULL,
  `name` varchar(20) default NULL,
  `surname` varchar(20) default NULL,
  `middlename` varchar(20) default NULL,
  `confirmed` tinyint(1) default '0',
  PRIMARY KEY  (`id`),
  KEY `author_FKIndex1` (`submitter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=41 ;

--
-- Vypisuji data pro tabulku `author`
--

INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (1, 4, 'Petr', 'Fišer', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (2, 4, 'Hana', 'Kubátová', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (3, 4, 'Pavel', 'Kubalík', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (5, 3, 'Marko', 'Berezovskyj', 'Genyk', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (9, 2, 'Roman', 'Berka', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (10, 3, 'Adam', 'Sporka', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (11, 3, 'Pavel', 'Slavík', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (13, 2, 'Jan', 'Kubr', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (14, 2, 'Jan', 'Janeček', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (16, 2, 'Jiří', 'Daněček', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (17, 2, 'Ivan', 'Halaška', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (18, 2, 'Ivan', 'Jelínek', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (19, 2, 'Josef', 'Kolář', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (20, 2, 'Karel', 'Müller', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (21, 2, 'Alois', 'Pluháček', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (22, 2, 'F', 'Drápal', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (23, 2, 'M', 'Servít', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (24, 2, 'Božena', 'MannovÃ¡', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (25, 2, 'M', 'Poláček', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (26, 2, 'J', 'Chludil', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (27, 2, 'Zdeněk', 'Troníček', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (28, 2, 'A', 'Shinohara', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (29, 2, 'Martin', 'Bílý', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (30, 2, 'A.', 'Balvínová¡', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (31, 2, 'Michal', 'Valenta', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (32, 2, 'Karel', 'Richta', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (33, 2, 'Jaroslav', 'Pokorný', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (34, 2, 'Martin', 'Koloros', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (35, 2, 'Pavel', 'Kordík', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (37, 2, 'Martin', 'Klíma', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (38, 2, 'Z.', 'Blažek', '', 1);
INSERT INTO `author` (`id`, `submitter_id`, `name`, `surname`, `middlename`, `confirmed`) VALUES (39, 2, 'Milan', 'Šimůnek', '', 1);

-- --------------------------------------------------------

--
-- Struktura tabulky `author_has_publication`
--

CREATE TABLE `author_has_publication` (
  `author_id` int(10) unsigned NOT NULL,
  `publication_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`author_id`,`publication_id`),
  KEY `author_has_publication_FKIndex1` (`author_id`),
  KEY `author_has_publication_FKIndex2` (`publication_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Vypisuji data pro tabulku `author_has_publication`
--

INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (1, 56);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (1, 60);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 55);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 56);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 57);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 58);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 59);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (2, 60);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (3, 57);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (3, 58);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (9, 32);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (9, 33);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (10, 32);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (10, 33);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (11, 32);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (11, 33);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (11, 41);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (11, 54);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (13, 34);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (14, 34);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (16, 35);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (16, 36);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (16, 37);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (17, 36);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (17, 46);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (18, 36);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (19, 36);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (19, 38);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (19, 39);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (19, 40);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (20, 36);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (21, 37);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (22, 37);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (23, 37);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (24, 39);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (25, 41);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (26, 41);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (26, 42);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (27, 43);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (27, 44);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (28, 43);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (29, 45);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (29, 46);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (30, 45);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (31, 47);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (31, 48);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (31, 49);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (31, 51);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (32, 47);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (33, 50);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (34, 52);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (35, 53);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (37, 54);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (38, 59);
INSERT INTO `author_has_publication` (`author_id`, `publication_id`) VALUES (39, 61);

-- --------------------------------------------------------

--
-- Struktura tabulky `categories`
--

CREATE TABLE `categories` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `submitter_id` int(10) unsigned default NULL,
  `name` varchar(40) NOT NULL,
  `confirmed` tinyint(1) default NULL,
  PRIMARY KEY  (`id`),
  KEY `categories_FKIndex1` (`submitter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=21 ;

--
-- Vypisuji data pro tabulku `categories`
--

INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (1, 4, 'mikroprocesory', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (2, 4, 'software', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (5, 3, 'hardware', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (6, 2, 'grafika', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (7, 2, 'sítě', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (9, 2, 'programování', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (10, 3, 'umělá int.', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (11, 3, 'U3V', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (12, 3, 'internet', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (13, 3, 'algoritmy', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (14, 2, 'databáze', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (15, 2, 'XML', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (16, 2, 'digitální média', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (17, 2, 'neurony', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (18, 2, 'sémantický web', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (19, 2, 'FPGA', 1);
INSERT INTO `categories` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (20, 2, 'logické obvody', 1);

-- --------------------------------------------------------

--
-- Struktura tabulky `categories_has_publication`
--

CREATE TABLE `categories_has_publication` (
  `publication_id` int(10) unsigned NOT NULL,
  `categories_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`publication_id`,`categories_id`),
  KEY `publication_has_categories_FKIndex1` (`publication_id`),
  KEY `publication_has_categories_FKIndex2` (`categories_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Vypisuji data pro tabulku `categories_has_publication`
--

INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (32, 6);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (33, 6);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (34, 7);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (35, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (36, 9);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (37, 1);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (38, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (38, 5);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (39, 11);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (39, 12);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (40, 10);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (40, 13);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (41, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (41, 6);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (42, 10);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (43, 10);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (44, 9);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (44, 10);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (45, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (46, 9);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (47, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (47, 9);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (48, 13);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (48, 14);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (49, 14);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (50, 14);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (51, 15);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (52, 16);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (53, 10);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (53, 17);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (54, 18);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (55, 5);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (55, 13);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (56, 13);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (57, 5);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (57, 19);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (58, 5);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (58, 19);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (59, 20);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (61, 2);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (61, 9);
INSERT INTO `categories_has_publication` (`publication_id`, `categories_id`) VALUES (61, 14);

-- --------------------------------------------------------

--
-- Struktura tabulky `format`
--

CREATE TABLE `format` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(40) NOT NULL,
  `content` text NOT NULL,
  `timestamp` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

--
-- Vypisuji data pro tabulku `format`
--

INSERT INTO `format` (`id`, `name`, `content`, `timestamp`) VALUES (1, 'TestFormat', '{if $pub_type==1}\r\n{if $language==1}\r\n  <strong>{$title}</strong> (Kniha)<br />\r\n  {if $year}{$year}, {/if}{$authors} <br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {if $city}{$city}, {/if}{if $publisher}{$publisher}, {/if}{$pp} s., ISBN {$isbn} {$files}\r\n{else}\r\n  <strong>{$title}</strong> (Book)<br />\r\n  {if $year}{$year}, {/if}{$authors} <br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {if $city}{$city}, {/if}{if $publisher}{$publisher}, {/if}pp {$pp}, ISBN {$isbn} {$files}\r\n{/if}\r\n\r\n{elseif $pub_type==2}\r\n{if $language==1}\r\n  <strong>{$title}</strong> (ÄŒlÃ¡nek)<br />\r\n  {if $_notice}{$_notice}<br />{/if}\r\n  {if $year}{$year}, {/if}{$authors} <br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {if $city}{$city}, {/if}{if $publisher}{$publisher}, {/if}vol. {$vol}, no. {$no}, {$pp} s., ISSN {$issn} {$files}\r\n{else}\r\n  <strong>{$title}</strong> (Article)<br />\r\n  {if $year}{$year}, {/if}{$authors} <br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {if $city}{$city}, {/if}{if $publisher}{$publisher}, {/if}vol. {$vol}, no. {$no}, pp {$pp}, ISSN {$issn} {$files}\r\n{/if}\r\n\r\n{elseif $pub_type==3}\r\n{if $language==1}\r\n  <strong>{$title}</strong> (StaÅ¥ ve sbornÃ­ku)<br />\r\n  {if $year}{$year}, {/if}{$authors}\r\n  {if $workshop_name}<br />NÃ¡zev konference: {$workshop_name},{/if}\r\n  {if $w_from}<br />Datum konÃ¡nÃ­: {$w_from} - {$w_to}{/if}<br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {$city}, {if $publisher}{$publisher}, {/if}{$pp} s. ISBN {$isbn} {$files}\r\n{else}\r\n  <strong>{$title}</strong> (Workshop)<br />\r\n  {if $year}{$year}, {/if}{$authors}\r\n  {if $workshop_name}<br />Workshop name: {$workshop_name},{/if}\r\n  {if $w_from}<br />Took place from {$w_from} to {$w_to}{/if}<br />\r\n  {if $country}{$country}{if $state} - {$state}{/if},{/if}\r\n  {if $city}{$city}, {/if}{if $publisher}{$publisher}, {/if}pp {$pp}, {$ixxn}: {$isbn} {$files}\r\n{/if}\r\n{/if}', 1151607927);
INSERT INTO `format` (`id`, `name`, `content`, `timestamp`) VALUES (2, 'APA', '{$authors}{if $year} ({$year}){/if}. {$title}. {if $publisher}{$publisher}, \r\n{/if}{if $vol}{$vol}, {/if}{$pp}.', 1151607948);

-- --------------------------------------------------------

--
-- Struktura tabulky `publication`
--

CREATE TABLE `publication` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `submitter_id` int(10) unsigned default NULL,
  `publisher_id` int(10) unsigned default NULL,
  `country_code` char(2) default NULL,
  `state_code` char(2) default NULL,
  `city` varchar(45) default NULL,
  `pub_type` tinyint(3) unsigned NOT NULL,
  `language` tinyint(3) unsigned NOT NULL,
  `title` text NOT NULL,
  `confirmed` tinyint(1) default '0',
  `issue_date` date default NULL,
  `w_from` date default NULL,
  `w_to` date default NULL,
  `workshop_name` text,
  `isbn` varchar(17) default NULL,
  `vol` int(10) unsigned default NULL,
  `no` int(10) unsigned default NULL,
  `pp` varchar(25) default NULL,
  PRIMARY KEY  (`id`),
  KEY `publication_FKIndex1` (`submitter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=63 ;

--
-- Vypisuji data pro tabulku `publication`
--

INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (32, 2, 0, '', '', 'Bratislava', 3, 1, 'VRI Exhibition', 1, '2004-01-01', '0000-00-00', '0000-00-00', 'Proceedings of SCCG (conference materials and posters)', '1335-5694', 0, 0, '47-51');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (33, 2, 7, 'CZ', '', 'VeszprÃ©m', 3, 1, 'A Formal Approach to The Development of Web Based Multimedia Presentations', 1, '2004-00-01', '0000-00-00', '0000-00-00', 'First Central European International Multimedia and Virtual Reality Conference', '963-9495-46-8', 0, 0, '145-154');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (34, 2, 2, 'CZ', '', 'Praha', 1, 1, 'Distribuované systémy: Cvičení', 1, '2000-01-01', '0000-00-00', '0000-00-00', '', '80-01-02099-1', 0, 0, '128');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (35, 2, 9, 'SK', '', 'KoÅ¡ice', 3, 1, 'Programovací systém MiniJava', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'Proceedings of the Computer Science Education Workshop 2001', '80-7099-705-2', 0, 0, '162-168');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (36, 2, 2, 'CZ', '', 'Praha', 1, 1, 'Výpočetní technika a programování II', 1, '1999-01-01', '0000-00-00', '0000-00-00', '', '80-01-01969-1', 0, 0, '188');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (37, 2, 2, 'CZ', '', 'Praha', 3, 2, 'Implementation of a General-Purpose Processor Macro', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'Workshop 96.', '', 0, 0, '245-246');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (38, 2, 11, 'CZ', '', 'Praha', 3, 2, 'What Makes a Programme In Mobile Technologies Successful', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'MoWeIT 2005 - Mobile Computing Meets Knowledge Management', '80-903198-0-7', 0, 0, '31-36');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (39, 2, 2, 'CZ', '', 'Praha', 3, 2, 'Seniors On-line', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'Proceedings of Workshop 2002', '80-01-02511-X', 0, 0, '378-379');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (40, 2, 11, 'CZ', '', 'Praha', 1, 1, 'Teoretická informatika', 1, '1996-01-01', '0000-00-00', '0000-00-00', '', '80-900853-4-2', 0, 0, '168');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (41, 2, 13, 'SK', '', 'Bratislava', 3, 2, 'System for Reconstruction of Celtic Archaeological Sites', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'Spring Conference on Computer Graphics SCCG 2002 - Conference Materials, Posters', '1335-5694', 0, 0, '58-59');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (42, 2, 2, 'CZ', '', 'Praha', 3, 2, 'Yacht Captain Training System in Virtual Environment', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'Poster 2001', '', 0, 0, '');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (43, 2, 14, 'DE', '', 'BerlÃ­n', 3, 2, 'The Size of Subsequence Automaton', 1, '0000-00-01', '0000-00-00', '0000-00-00', 'String Processing and Information Retrieval', '3-540-20177-7', 0, 0, '304-310');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (44, 2, 0, '', '', '', 2, 2, 'Episode Directed Acyclic Subsequence Graph', 1, '2004-11-01', '0000-00-00', '0000-00-00', '', '1236-6064', 11, 1, '35-40');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (45, 2, 2, 'CZ', '', 'Praha', 1, 1, 'Textové informační systémy - cvičení', 1, '1996-01-01', '0000-00-00', '0000-00-00', '', '80-01-01201-8', 0, 0, '63');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (46, 2, 2, 'CZ', '', 'Praha', 1, 2, 'Introduction to Computer Programming I', 1, '1993-01-01', '0000-00-00', '0000-00-00', '', '80-01-00947-5', 0, 0, '57');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (47, 2, 16, '', '', 'Ostrava', 3, 1, 'OBJ3 a LEGO jako nástroje pro specifikaci funkčního modelu', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'Tvorba softwaru''98', '80-86122-15-8', 0, 0, '147-157');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (48, 2, 17, 'CZ', '', 'Brno', 3, 2, 'Memory Access Methods in Parallel Database Systems', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'DATASEM''97', '80-238-1176-2', 0, 0, '139-151');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (49, 2, 10, 'CZ', '', 'Prague', 3, 2, 'XML-Lambda Model', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'Poster 2001', '', 0, 0, '');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (50, 2, 2, 'CZ', '', 'Praha', 1, 1, 'Databázové systémy, cvičení', 1, '2003-01-01', '0000-00-00', '0000-00-00', '', '80-01-02612-4', 0, 0, '138');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (51, 2, 18, 'CZ', '', 'Brno', 3, 2, 'Models of XML Data Transformations', 1, '0000-00-00', '0000-00-00', '0000-00-00', '', '80-210-2958-7', 0, 0, '243-252');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (52, 2, 0, '', '', '', 3, 2, 'Shape matching in vectorized cartoon video', 1, '0000-00-01', '0000-00-00', '0000-00-00', '', '234-990-12-80', 0, 0, '12-15');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (53, 2, 0, 'UA', '', 'Kyjev', 3, 2, 'Why Bagging of GAME Inductive Models Does Not Futher Improve their Accuracy?', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'roceedings of the International Workshop on Inductive Modeling IWIM-2005', '966-02-3734-0', 0, 0, '13-20');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (54, 2, 19, 'US', 'NJ', 'Mahwah', 3, 2, 'Collaborative Work with Adapted Data', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'HCI International 2005', '', 0, 0, '');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (55, 2, 1, '', '', '', 2, 2, 'Modeling by Petri Nets', 1, '2005-01-01', '0000-00-00', '0000-00-00', '', '1210-2709', 45, 2, '5-13');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (56, 2, 1, '', '', '', 2, 2, 'Pseudorandom Testability - Study of the Effect of the Generator Type', 1, '2005-01-01', '0000-00-00', '0000-00-00', '', '1210-2709', 45, 2, '47-54');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (57, 2, 9, '', '', 'KoÅ¡ice', 3, 2, 'On-line Testing for FPGA', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'Proceedings of the Sixth International Scientific Conference Electronic Computers and Informatics ECI', '80-8073-150-0', 0, 0, '194-199');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (58, 2, 20, '', '', 'Cairo', 3, 2, 'Design of Self Checking Circuits Based on FPGA', 1, '0000-00-00', '0000-00-00', '0000-00-00', 'Proceedings of the 15th International Conference on Microelectronics', '977-05-2010-1', 0, 0, '378-381');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (59, 2, 2, 'CZ', '', 'Praha', 1, 1, 'Logické systémy - cvičení', 1, '1995-01-01', '0000-00-00', '0000-00-00', '', '80-01-01227-1', 0, 0, '105');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (60, 2, 3, '', '', '', 2, 2, 'Pseudorandom Testability - Study of the Effect of the Generator Type', 0, '2005-01-01', '0000-00-00', '0000-00-00', '', '1210-2709', 45, 2, '47-54');
INSERT INTO `publication` (`id`, `submitter_id`, `publisher_id`, `country_code`, `state_code`, `city`, `pub_type`, `language`, `title`, `confirmed`, `issue_date`, `w_from`, `w_to`, `workshop_name`, `isbn`, `vol`, `no`, `pp`) VALUES (61, 2, 3, 'CZ', '', 'Praha', 1, 1, 'SQL - Kompletní kapesní průvodce', 1, '1999-01-01', '0000-00-00', '0000-00-00', '', '80-7169-692-7', 0, 0, '247');

-- --------------------------------------------------------

--
-- Struktura tabulky `publisher`
--

CREATE TABLE `publisher` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `submitter_id` int(10) unsigned default NULL,
  `name` varchar(45) default NULL,
  `confirmed` tinyint(1) default '0',
  PRIMARY KEY  (`id`),
  KEY `publisher_FKIndex1` (`submitter_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=21 ;

--
-- Vypisuji data pro tabulku `publisher`
--

INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (1, 4, 'Acta Polytechnica', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (2, 3, 'Vydavatelství ČVUT', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (3, 3, 'Grada', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (4, 3, 'Soft Press', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (5, 3, 'SPN', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (7, 2, 'Veszprém University Press', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (9, 2, 'Technical University Košice', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (10, 2, 'CTU', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (11, 2, 'Česká informatická společnost', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (12, 2, 'Computer World', 0);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (13, 2, 'Comenius University', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (14, 2, 'Springer', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (16, 2, 'Tanger', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (17, 2, 'CS-COMPEX', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (18, 2, 'Masaryk University', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (19, 2, 'Awrence Erlbaum Asso', 1);
INSERT INTO `publisher` (`id`, `submitter_id`, `name`, `confirmed`) VALUES (20, 2, 'Cairo University', 1);

-- --------------------------------------------------------

--
-- Struktura tabulky `submitter`
--

CREATE TABLE `submitter` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `ctu_login` varchar(7) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=4 ;

--
-- Vypisuji data pro tabulku `submitter`
--

INSERT INTO `submitter` (`id`, `ctu_login`) VALUES (1, 'admin');
INSERT INTO `submitter` (`id`, `ctu_login`) VALUES (2, 'guest');
INSERT INTO `submitter` (`id`, `ctu_login`) VALUES (3, 'vodicm1');
INSERT INTO `submitter` (`id`, `ctu_login`) VALUES (4, 'fiserp');

--
-- Omezení pro exportované tabulky
--

--
-- Omezení pro tabulku `attrib_storage`
--
ALTER TABLE `attrib_storage`
  ADD CONSTRAINT `attrib_storage_ibfk_1` FOREIGN KEY (`attributes_id`) REFERENCES `attributes` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `attrib_storage_ibfk_2` FOREIGN KEY (`publication_id`) REFERENCES `publication` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `attrib_storage_ibfk_3` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Omezení pro tabulku `attributes`
--
ALTER TABLE `attributes`
  ADD CONSTRAINT `attributes_ibfk_1` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Omezení pro tabulku `author`
--
ALTER TABLE `author`
  ADD CONSTRAINT `author_ibfk_1` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Omezení pro tabulku `author_has_publication`
--
ALTER TABLE `author_has_publication`
  ADD CONSTRAINT `author_has_publication_ibfk_1` FOREIGN KEY (`author_id`) REFERENCES `author` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `author_has_publication_ibfk_2` FOREIGN KEY (`publication_id`) REFERENCES `publication` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Omezení pro tabulku `categories`
--
ALTER TABLE `categories`
  ADD CONSTRAINT `categories_ibfk_1` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Omezení pro tabulku `categories_has_publication`
--
ALTER TABLE `categories_has_publication`
  ADD CONSTRAINT `categories_has_publication_ibfk_1` FOREIGN KEY (`publication_id`) REFERENCES `publication` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  ADD CONSTRAINT `categories_has_publication_ibfk_2` FOREIGN KEY (`categories_id`) REFERENCES `categories` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Omezení pro tabulku `publication`
--
ALTER TABLE `publication`
  ADD CONSTRAINT `publication_ibfk_1` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

--
-- Omezení pro tabulku `publisher`
--
ALTER TABLE `publisher`
  ADD CONSTRAINT `publisher_ibfk_1` FOREIGN KEY (`submitter_id`) REFERENCES `submitter` (`id`) ON DELETE SET NULL ON UPDATE CASCADE;

SET FOREIGN_KEY_CHECKS=1;

COMMIT;
