{php}
	require_once('../common/Bibtex.inc.php');
	$b = Bibtex::create($_SESSION['feedback_st1']['pub_type']);
{/php}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<title>Database of publication - further information</title>
	<link rel="stylesheet" type="text/css" href="load.css" />
	<link rel="stylesheet" type="text/css" href="../common/header.css" />
	<script src="../admin/modify_publication.js" type="text/javascript"></script>
</head>
<body onload="init_ajax();">
	{include file="header.tpl"}

	<div id="mainpanel">
	<div id="mainpanel-inside">
		{if $operation_error}
			<span class="error">{$operation_error}</span><br/>
		{elseif $operation_success}
			<span class="success">{$operation_success}</span><br/>
		{/if}
		<form action="index.php" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
		<table border="0" cellspacing="0" cellpadding="10" summary="Input of a new publication">
		{if $dpub_type eq 'inproceendins' or $dpub_type eq 'incollection'}
			<tr>
				<td>
					Booktitle{php}$b->star('booktitle');{/php}:
				</td>
				<td>
					<input type="text" name="booktitle" id="booktitle" size="20" value="{$booktitle}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'article' or $dpub_type eq 'book' or $dpub_type eq 'inbook' or $dpub_type eq 'incollection' or $dpub_type eq 'inproceedings' or $dpub_type eq 'proceedings' or $dpub_type eq 'techreport'}
			{if $dpub_type neq 'techreport'}
			<tr>
				<td>Volume{php}$b->star('volume');{/php}:</td>
				<td><input type="text" name="volume" id="volume" size="20" value="{$volume}" /></td>
			</tr>
			{/if}
			<tr>
				<td>Number:</td>
				<td><input type="text" name="number" id="number" size="20" value="{$number}" /></td>
			</tr>
		{/if}
		{if $dpub_type eq 'inbook' or $dpub_type eq 'incollection' or $dpub_type eq 'inproceedings'}
			<tr>
				<td>
					Chapter{php}$b->star('chapter');{/php}:
				</td>
				<td>
					<input type="text" name="chapter" id="chapter" size="20" value="{$chapter}" />
				</td>
			</tr>
		{/if}
			<tr>
				<td>
					Pages{php}$b->star('pages');{/php}:
				</td>
				<td>
					<input type="text" name="pages" id="pages" size="20" value="{$pages}" />
				</td>
			</tr>
		{if $dpub_type eq 'book' or $dpub_type eq 'inbook' or $dpub_type eq 'incollection' or $dpub_type eq 'proceedings'}
			<tr>
				<td>
					Series{php}$b->star('series');{/php}:
				</td>
				<td>
					<input type="text" name="series" id="series" size="20" value="{$series}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'booklet' or $dpub_type eq 'misc'}
			<tr>
				<td>
					Howpublished{php}$b->star('howpublished');{/php}:
				</td>
				<td>
					<input type="text" name="howpublished" id="howpublished" size="40" value="{$howpublished}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'techreport'}
			<tr>
				<td>
					Typ reportu (například "Research Note"){php}$b->star('type');{/php}:
				</td>
				<td>
					<input type="text" name="type" id="type" size="20" value="{$type}" />
				</td>
			</tr>
			<tr>
				<td>
					Institution{php}$b->star('institution');{/php}:
				</td>
				<td>
					<input type="text" name="institution" id="institution" size="20" value="{$institution}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type neq 'proceedings'}
			<tr>
				<td>
					Authors{php}$b->star('author');{/php}:
				</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0" summary="authors">
					<tr>
						<td colspan="3">
							<table border="0" cellpadding="0" cellspacing="0" summary="add_author">
							<tr>
								<td>name</td>
								<td>middle.</td>
								<td>surname</td>
								<td>&nbsp;</td>
							</tr>
							<tr>
								<td><input type="text" name="author_name" id="author_name" size="12" value="" /></td>
								<td><input type="text" name="author_middle_name" id="author_middle_name" size="12" value="" /></td>
								<td><input type="text" name="author_surname" id="author_surname" size="12" value="" /></td>
								<td><input type="submit" name="add_author" value="add author" /></td>
							</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td>
							<select style="width:390px;" multiple="multiple" name="authors[]" id="authors" size="10">
							{html_options options=$authors}
							</select>
							<br />
							<input type="submit" name="delete_author" value="delete chosen authors" />
						</td>
						<td>
							<input type="submit" name="select_author" value="&gt;&gt;" />
							<br />
							<input type="submit" name="deselect_author" value="&lt;&lt;" />
						</td>
						<td>
							<select style="width:390px;" name="selected_authors[]" id="selected_authors" size="10" title="chosen authors">
							{html_options values=$selected_authors output=$selected_authors_names}
							</select>
						</td>
					</tr>
					</table>
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'book' or $dpub_type eq 'inbook'}
			<tr>
				<td>
					Editor{php}$b->star('editor');{/php}:
				</td>
				<td>
					<input type="text" name="editor" id="editor" size="20" value="{$editor}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'article'}
			<tr>
				<td>
					Journal{php}$b->star('journal');{/php}:
				</td>
				<td>
					<fieldset class="detail_panel">
						<div id="journal_label" class="edit_label" onclick="disable_journal_edit();">
							You can edit the journal. Click here to abort editing.
						</div>
						<label>Name*: <input id="journal_name" size="70" type="text" name="journal_name" /></label><br />
						<label>ISSN: <input id="journal_issn" size="20" type="text" name="journal_issn" /></label>
						<div class="right">
							<input id="add_journal" type="submit" name="add_journal" value="add journal" />
							<input id="update_journal" style="display: none;" type="submit" name="update_journal" value="update journal" />
						</div>
						<br />
						<select name="journal" id="journal_sel" size="10">
						{html_options options=$journal selected=$selected_journal}
						</select>
						<br />
						<input type="button" onclick="unset_memo('journal_sel');" value="unset journal" />
						<input type="submit" name="delete_journal" value="delete journal" />
						<br />
					</fieldset>
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'proceedings' or $dpub_type eq 'inproceedings'}
			<tr>
				<td>
					Conference*:
				</td>
				<td>
					<fieldset class="detail_panel">
						<div id="conference_label" class="edit_label" onclick="disable_conference_edit();">
							You can edit the conference. Click here to abort editing.
						</div>
						<label>Name*: <input id="conference_name" type="text" size="70" name="conference_name" value="{$conference_name}" /></label><br />
						<label>Abbreviation: <input id="conference_abbreviation" type="text" size="20" name="conference_abbreviation" value="{$conference_abbreviation}" /></label><br />
						<label>Year: <input id="w_year" type="text" name="w_year" size="10" value="{$w_year}" /></label>
						<label>From: <input id="w_from" type="text" name="w_from" size="10" value="{$w_from}" maxlength="10" /></label>
						<label>To: <input id="w_to" type="text" name="w_to" size="10" value="{$w_to}" maxlength="10" /></label>
						<br />
						<label>Location:
							<input id="location" type="text" size="40" name="location" value="{$location}" />
						</label>
						<br />
						<label>ISBN: <input id="conference_isbn" type="text" name="isbn" size="20" value="{$isbn}" /></label>
						<div class="right">
							<input id="add_conference" type="submit" name="add_conference" value="add conference" />
							<input id="update_conference" style="display: none;" type="submit" name="update_conference" value="update conference" />
						</div>
						<br />
						<script type="text/javascript">
							forbidden_conferences = {$forbidden_conferences};
						</script>
						<select name="conference" id="conference_sel" size="10">
						{html_options options=$conference selected=$selected_conference}
						</select>
						<input type="button" onclick="unset_memo('conference_sel');" value="unset conference" />
						<input type="submit" name="delete_conference" value="delete conference" />
						<br />
					</fieldset>
				</td>
				<td>
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'book' or $dpub_type eq 'inbook' or $dpub_type eq 'incollection' or $dpub_type eq 'inproceedings' or $dpub_type eq 'proceedings'}
			<tr>
				<td>
					Publisher{php}$b->star('publisher');{/php}:
				</td>
				<td>
					<fieldset class="detail_panel">
						<div id="publisher_label" class="edit_label" onclick="disable_publisher_edit();">
							You can edit the publisher. Click here to abort editing.
						</div>
						<label>Name*: <input id="publisher_name" size="70" type="text" name="publisher_name" /></label><br />
						<label>Address: <input id="publisher_address" size="70" type="text" name="publisher_address" /></label>
						<div class="right">
							<input id="add_publisher" type="submit" name="add_publisher" value="add publisher" />
							<input id="update_publisher" style="display: none;" type="submit" name="update_publisher" value="update publisher" />
						</div>
						<select id="publisher_sel" name="publisher" size="10">
						{html_options options=$publisher selected=$selected_publisher}
						</select>
						<input type="button" onclick="unset_memo('publisher_sel');" value="unset publisher" />
						<input type="submit" name="delete_publisher" value="delete publisher" />
						<br />
					</fieldset>
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'book' || $dpub_type eq 'inbook' || $dpub_type eq 'incollection'}
			<tr>
				<td>
					ISBN:
				</td>
				<td>
					<input type="text" name="isbn" id="isbn" maxlength="17" size="20" value="{$isbn}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'mastersthesis' || $dpub_type eq 'phdthesis'}
			<tr>
				<td>
					School{php}$b->star('school');{/php}:
				</td>
				<td>
					<input type="text" name="school" id="school" size="40" value="{$school}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'inproceedings' || $dpub_type eq 'manual' || $dpub_type eq 'proceedings'}
			<tr>
				<td>
					Organization{php}$b->star('organization');{/php}:
				</td>
				<td>
					<input type="text" name="organization" id="organization" size="20" value="{$organization}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type neq 'inproceedings' || $dpub_type neq 'proceedings'}
			<tr>
				<td>
					Year{php}$b->star('year');{/php} and month{php}$b->star('month');{/php} of publication:
					<br />(YYYY) nebo (YYYY-MM)
				</td>
				<td>
					<input type="text" name="issue_date" id="issue_date" maxlength="7" size="20" value="{$issue_date}" />
				</td>
			</tr>
		{/if}
		{if $dpub_type eq 'book' or $dpub_type eq 'inbook' or $dpub_type eq 'incollection' or $dpub_type eq 'manual'}
			<tr>
				<td>
					Edition{php}$b->star('edition');{/php}:
				</td>
				<td>
					<input type="text" name="edition" id="edition" size="40" value="{$edition}" />
				</td>
			</tr>
		{/if}
		{if $pub_type eq 'booklet' or $pub_type eq 'techreport' or $pub_type eq 'manual' or $pub_type eq 'mastersthesis' or $pub_type eq 'phdthesis'}
			<tr>
				<td>
					Address{php}$b->star('address');{/php}:
				</td>
				<td>
					<input type="text" name="address" id="address" size="20" value="{$address}" />
				</td>
			</tr>
		{/if}
		<tr>
			<td>
				Note{php}$b->star('note');{/php}:
			</td>
			<td>
				<input type="text" name="note" id="note" size="40" value="{$note}" />
			</td>
		</tr>
		<tr>
			<td>
				URL:
			</td>
			<td>
				<input type="text" name="url" id="url" size="40" value="{$url}" />
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<br /><br /><br />
				Further attributes - do not insert if they do not correspond with the purpose of the publication:
			</td>
		</tr>
		<!-- extra attributes -->
		{$attributes}
		<!-- END -->
		<!-- temporarily added attributes -->
		{$tmp_attr}
		<!-- END -->
		<tr>
			<td class="attribut_add" colspan="2">
				<fieldset>
				<legend>You can add a new attribute</legend>
				<dl class="liketable_two">
					<dt><label for="new_attribute_name">name&nbsp;of attribute: </label></dt>
					<dd><input type="text" id="new_attribute_name" name="new_attribute_name" maxlength="32" value="{$new_attribute_name}" /><span>&nbsp; *first character underline, othera characters letters and numerals.</span></dd>

					<dt><label for="new_attribute_value">hodnota&nbsp;atributu: </label></dt>
					<dd><input type="text" id="new_attribute_value" name="new_attribute_value" value="{$new_attribute_value}" /></dd>

					<dt><label for="new_attribute_description">popisek&nbsp;atributu: </label></dt>
					<dd><input type="text" id="new_attribute_description" name="new_attribute_description" maxlength="255" value="{$new_attribute_description}" /><span>&nbsp; *max. 255 characters, optional</span></dd>
				</dl>
				<input type="submit" name="delete_attributes" value="remove additional attributes" />
				<input type="submit" name="add_attribute" class="highlighted" value="add" />
				</fieldset>
			</td>
		</tr>
		<tr>
			<td class="left">
				<input type="hidden" name="prev_stage" value="1" />
				<input type="submit" name="previous" value="&lt;&lt; previous" />
			</td>
			<td class="right">
				<input type="hidden" name="next_stage" value="3" />
				<input type="submit" name="next" value="next &gt;&gt;" />
			</td>
		</tr>
		</table>
		</form>
	</div>
	</div>
</body></html>